----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    20:39:44 02/11/2014 
-- Design Name: 
-- Module Name:    main - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity main is
GENERIC(
      counter_size : INTEGER:= 8);
  PORT(
--	 dxsolve : IN STD_LOGIC;
    CLK          : IN  STD_LOGIC;                     --system clock
	 ps2_clk1      : IN  STD_LOGIC;                     --clock signal from PS/2 keyboard
    ps2_data1    : IN  STD_LOGIC;                     --data signal from PS/2 keyboard
    LED     : OUT STD_LOGIC_VECTOR(7 DOWNTO 0));
end main;

architecture Behavioral of main is

COMPONENT ps2_keyboard_to_ascii IS
  GENERIC(
      clk_freq                  : INTEGER := 50_000_000; --system clock frequency in Hz
      ps2_debounce_counter_size : INTEGER := 8);         --set such that 2^size/clk_freq = 5us (size = 8 for 50MHz)
  PORT(
      clk        : IN  STD_LOGIC;                     --system clock input
      ps2_clk    : IN  STD_LOGIC;                     --clock signal from PS2 keyboard
      ps2_data   : IN  STD_LOGIC;                     --data signal from PS2 keyboard
      ascii_new  : OUT STD_LOGIC                     --output flag indicating new ASCII value
      --ascii_code : OUT STD_LOGIC_VECTOR(6 DOWNTO 0)
		); --ASCII value
END COMPONENT;

COMPONENT ps2_keyboard IS
    GENERIC(
      counter_size : INTEGER:= 8); --debounce period (in seconds) = 2^counter_size/(clk freq in Hz)
    PORT(
      clk    : IN  STD_LOGIC;  --input clock
		ps2_clk      : IN  STD_LOGIC;                     --clock signal from PS/2 keyboard
      ps2_data    : IN  STD_LOGIC;                     --data signal from PS/2 keyboard
      --ps2_code_new : OUT  STD_LOGIC;  --input signal to be debounced
      ps2_code : OUT STD_LOGIC_VECTOR(7 DOWNTO 0)); --debounced signal
END COMPONENT;

SIGNAL output  : STD_LOGIC_VECTOR(7 DOWNTO 0); 
--SIGNAL truedxsolve  : STD_LOGIC;
SIGNAL nextdude  : STD_LOGIC;
--SIGNAL truedx : STD_LOGIC;
SIGNAL moveit : STD_LOGIC;
SIGNAL put_dispenser_here : STD_LOGIC;
SIGNAL dispenspy : STD_LOGIC;
SIGNAL nopedude  : STD_LOGIC;
SIGNAL yesdude  : STD_LOGIC;
SIGNAL yesmydude  : STD_LOGIC;
SIGNAL dxaddon  : STD_LOGIC; 
SIGNAL misticflag  : STD_LOGIC; 
SIGNAL ps2_code_new  : STD_LOGIC; 
SIGNAL ps2_code  : STD_LOGIC_VECTOR(7 DOWNTO 0); 
SIGNAL phase: natural range 0 to 10; 
SIGNAL uno  : STD_LOGIC_VECTOR(7 DOWNTO 0); 
SIGNAL dos  : STD_LOGIC_VECTOR(7 DOWNTO 0); 
SIGNAL tres  : STD_LOGIC_VECTOR(7 DOWNTO 0); 
SIGNAL returnme  : STD_LOGIC_VECTOR(7 DOWNTO 0); 
SIGNAL katax1  : STD_LOGIC_VECTOR(7 DOWNTO 0); 
SIGNAL katax2  : STD_LOGIC_VECTOR(7 DOWNTO 0); 
SIGNAL katax3  : STD_LOGIC_VECTOR(7 DOWNTO 0); 
SIGNAL katax4  : STD_LOGIC_VECTOR(7 DOWNTO 0); 
SIGNAL mistic  : STD_LOGIC_VECTOR(7 DOWNTO 0);

begin
  ps2_main: ps2_keyboard
    GENERIC MAP(counter_size => counter_size)
    PORT MAP(clk => clk, ps2_code => ps2_code, ps2_clk => ps2_clk1, ps2_data => ps2_data1);
	 
  ps2_support: ps2_keyboard_to_ascii
    PORT MAP(clk => clk, ascii_new => ps2_code_new, ps2_clk => ps2_clk1, ps2_data => ps2_data1);
	
led<=output;
	
process(clk)
begin



if(clk'event and clk='1') then
--if(truedx<='0') then
--truedxsolve<=dxsolve;
--end if;
--if(truedxsolve='0' and dxsolve='0') then
--truedx<='0';
--end if;
--if(truedxsolve='1') then
--truedx<='1';
--truedxsolve<='0';
--output <= conv_std_logic_vector(phase,8);
--output(7)<=ps2_code_new;
--output(2 downto 0)<=katax1(2 downto 0);
--output(5 downto 3)<=returnme(2 downto 0);
--returnme<=conv_std_logic_vector(phase,8);
--output(6)<=truedx;
--output(7)<=truedxsolve;
--if(truedx<='0') then
--truedx<=nopedude;
--end if;
--if(truedxsolve<='0') then
--truedxsolve<=misticflag;
--end if;
--if(dxsolve='1') then
--truedx<='0';
--truedxsolve<='0';
--end if;


if (dxaddon='1' and ps2_code_new='0') then
dxaddon<='0';
end if;

if(ps2_code="01110110" and ps2_code_new='1') then
nextdude<='1';
output<="00000000";
end if; 

if(ps2_code="01011010" and ps2_code_new='1' and dxaddon='0') then
dxaddon<='1';
yesdude<='1';
end if; 

if(nextdude='1' or nopedude='1') then
phase<=0;
nextdude<='0';
nopedude<='0';
yesdude<='0';
misticflag<='0';
returnme<="00000000";
uno<="00000000";
dos<="00000000";
tres<="00000000";
end if;
 
if(nopedude='1') then
output<="11111111";
end if;

if(yesdude='1') then
case tres is
when "00010110" =>
	tres<="00000001";
	returnme<="00000001";
	when "00011110" =>
	tres<="00000010";
	returnme<="00000010";
	when "00100110" =>
	tres<="00000011";
	returnme<="00000011";
	when "00100101" =>
	tres<="00000100";
	returnme<="00000100";
	when "00101110" =>
	tres<="00000101";
	returnme<="00000101";
	when "00110110" =>
	tres<="00000110";
	returnme<="00000110";
	when "00111101" =>
	tres<="00000111";
	returnme<="00000111";
	when "00111110" =>
	tres<="00001000";
	returnme<="00001000";
	when "01000110" =>
	tres<="00001001";
	returnme<="00001001";
	when "01001110" =>
	tres<="00001010";
	returnme<="00001010";
	when "01010101" =>
	tres<="00001011";
	returnme<="00001011";
	when "01100110" =>
	tres<="00001100";
	returnme<="00001100";
	when "01010100" =>
	tres<="00001101";
	returnme<="00001101";
	when "01011011" =>
	tres<="00001110";
	returnme<="00001110";
	when "01011101" =>
	tres<="00001111";
	returnme<="00001111";
	when "01000101" =>
	tres<="00000000";
	returnme<="00000000";
	when "01000100" =>
	returnme<=katax1;
	when "01001011" =>
	returnme<=katax2;
	when "01000010" =>
	returnme<=katax3;
	when "01000011" =>
	returnme<=katax4;
	when others =>null;
end case;
yesdude<='0';
yesmydude<='1';
end if;

if(yesmydude='1') then
case uno is 
when "00111010" => 
	moveit<='1';
when "00110011" => 
	case dos is
	when "01000100" =>
	output<=katax1;
	when "01001011" =>
	output<=katax2;
	when "01000010" =>
	output<=katax3;
	when "01000011" =>
	output<=katax4;
	when others =>nopedude<='1';
	end case;
	nextdude<='1';
when "00011100"=>
	case dos is
	when "01000100" =>
	katax1<=katax1+returnme;
	when "01001011" =>
	katax2<=katax2+returnme;
	when "01000010" =>
	katax3<=katax3+returnme;
	when "01000011" =>
	katax4<=katax4+returnme;
	when others =>nopedude<='1';
	end case;
	nextdude<='1';
when "00011011"=>
	case dos is
	when "01000100" =>
	katax1<=katax1-returnme;
	when "01001011" =>
	katax2<=katax2-returnme;
	when "01000010" =>
	katax3<=katax3-returnme;
	when "01000011" =>
	katax4<=katax4-returnme;
	when others =>nopedude<='1';
	end case;
	nextdude<='1';
when "00100010"=>
	case dos is
	when "01000100" =>
	katax1<=katax1*returnme;
	when "01001011" =>
	katax2<=katax2*returnme;
	when "01000010" =>
	katax3<=katax3*returnme;
	when "01000011" =>
	katax4<=katax4*returnme;
	when others =>nopedude<='1';
	end case;
	nextdude<='1';
when "00101100"=>
	put_dispenser_here<='1';
case dos is
when "00010110" =>
	dos<="00000001";
	when "00011110" =>
	dos<="00000010";
	when "00100110" =>
	dos<="00000011";
	when "00100101" =>
	dos<="00000100";
	when "00101110" =>
	dos<="00000101";
	when "00110110" =>
	dos<="00000110";
	when "00111101" =>
	dos<="00000111";
	when "00111110" =>
	dos<="00001000";
	when "01000110" =>
	dos<="00001001";
	when "01001110" =>
	dos<="00001010";
	when "01010101" =>
	dos<="00001011";
	when "01100110" =>
	dos<="00001100";
	when "01010100" =>
	dos<="00001101";
	when "01011011" =>
	dos<="00001110";
	when "01011101" =>
	dos<="00001111";
	when "01000101" =>
	dos<="00000000";
	when others =>nopedude<='1';
end case;

when others =>nopedude<='1';
end case;
yesmydude<='0';
end if; 

if(put_dispenser_here='1' and nopedude<='0')then
dos<=dos*"00010000";
dispenspy<='1';
put_dispenser_here<='0';
end if;

if(dispenspy='1' and nopedude<='0')then
katax1<=dos+tres;
nextdude<='1';
dispenspy<='0';
end if;

if(moveit='1')then
case tres is 
	when "01000100" =>
	mistic<=katax1;
	misticflag<='1';
	when "01001011" =>
	mistic<=katax2;
	misticflag<='1';
	when "01000010" =>
	mistic<=katax3;
	misticflag<='1';
	when "01000011" =>
	mistic<=katax4;
	misticflag<='1';
	when "00000001" =>
	mistic<="00000001";
	misticflag<='1';
	when "00000010" =>
	mistic<="00000010";
	misticflag<='1';
	when "00000011" =>
	mistic<="00000011";
	misticflag<='1';
	when "00000100" =>
	mistic<="00000100";
	misticflag<='1';
	when "00000101" =>
	mistic<="00000101";
	misticflag<='1';
	when "00000110" =>
	mistic<="00000110";
	misticflag<='1';
	when "00000111" =>
	mistic<="00000111";
	misticflag<='1';
	when "00001000" =>
	mistic<="00001000";
	misticflag<='1';
	when "00001001" =>
	mistic<="00001001";
	misticflag<='1';
	when "00001010" =>
	mistic<="00001010";
	misticflag<='1';
	when "00001011" =>
	mistic<="00001011";
	misticflag<='1';
	when "00001100" =>
	mistic<="00001100";
	misticflag<='1';
	when "00001101" =>
	mistic<="00001101";
	misticflag<='1';
	when "00001110" =>
	mistic<="00001110";
	misticflag<='1';
	when "00001111" =>
	mistic<="00001111";
	misticflag<='1';
	when "00000000" =>
	mistic<="00000000";
	misticflag<='1';
	when others =>nopedude<='1';
	end case;
	moveit<='0';
	nextdude<='1';
end if;

if(misticflag='1') then
case dos is 
when "01000100" =>
katax1<=mistic;
when "01001011" =>
katax2<=mistic;
when "01000010" =>
katax3<=mistic;
when "01000011" =>
katax4<=mistic;
when others =>nopedude<='1';
end case;
misticflag<='0';
end if;


 case phase is 
 when 0 =>  
 if(ps2_code_new='1' and dxaddon='0') then
 uno<=ps2_code;
 phase<=1;
 dxaddon<='1';
 end if;
 when 1 => 
 if(ps2_code_new='1' and dxaddon='0') then
 dos<=ps2_code;
 phase<=2;
 dxaddon<='1';
 end if;
 when 2 => 
 if(ps2_code_new='1' and dxaddon='0') then
 tres<=ps2_code;
 phase<=3;
 dxaddon<='1';
 end if;
 when 3 => 
 if(ps2_code_new='1' and dxaddon='0') then
-- returnme<=ps2_code;
 if(ps2_code="01011010")then
 --yesdude<='1';
 phase<=4;
 dxaddon<='1';
 else
 nopedude<='1';
 end if;
 end if;
 when others =>null; 
 end case; 

end if; 
--end if;
end process;


end Behavioral;

